Subject: Re: [BUG?] bonding, slave selection, carrier loss, etc.

From: Chris Friesen <[email-masked]>
Date: Mon, 13 Feb 2012 13:18:45 -0600

On 02/13/2012 12:48 PM, Stephen Hemminger wrote:
> On Mon, 13 Feb 2012 12:16:59 -0600
> Chris Friesen<[email-masked]>  wrote:
>
>> On 02/11/2012 12:52 PM, Ben Hutchings wrote:
>>> On Fri, 2012-02-10 at 17:53 -0800, Jay Vosburgh wrote:
>>>> Chris Friesen<[email-masked]>   wrote:
>>
>>>>> The best solution would be for bonding to just register for notification
>>>>> of the link going down.  Presumably most drivers should be doing that
>>>>> properly by now, and for devices that get interrupt-driven notification
>>>>> of link status changes this would allow the bonding code to react much
>>>>> quicker.
>>>>
>>>> 	A quick look at some drivers shows that at least acenic still
>>>> doesn't do netif_carrier_off, so converting entirely to a notifier-based
>>>> failover mechanism would break drivers that work today.
>>> [...]
>>>
>>> It might be worth having some sort of feature flag (in priv_flags) that
>>> indicates whether the driver updates the link state.  Alternately,
>>> disable polling of a device once you see a notification.
>
> Just fix the drivers to update link state.
> The whole mii polling method of bonding is really leftover from the era of
> 10 years ago when network drivers were stupid and didn't handle carrier.

In the interest of getting the bonding driver fixed sooner rather than 
later, I'd prefer something that didn't require fixing up all the 
network drivers first.

Once all the drivers are fixed up (assuming people care enough about 
older drivers to do so) then we could remove the option and make it 
mandatory.

Chris

-- 
Chris Friesen
Software Developer
GENBAND
[email-masked]
www.genband.com